"""Creates characteristics for personalities of leaders"""
import random

TRAITS = ('tactician', 'macroeconomic', 'genius', 'administrative')

def createChar():
	"""Creates a characteristic dictionary of (key = trait, value = traitness),
e.g. {'militaristic':25}, with traitness values adding up to 100"""
	traits = []
	#for i in range(random.randint(1, 2)): #A leader may have up to 2 positive traits
	traits.append(random.choice(TRAITS)) #Note that there may be duplicate traits in the list.
	#That simply means the values for both traits are added later.
	characteristics = dict()
	value = random.randint(50, 100) #Pool of numbers to draw traitness from
	used = 0
	for trait in traits:
		if value > 0:
			traitness = random.randint(25, value)
			if trait not in characteristics:
				characteristics[trait] = traitness
			else:
				characteristics[trait] += traitness
			value -= traitness
			used += traitness
	#Ignore leftover values, simply balance using negative traits
	#Now, balance it out by adding in negative traits
	while used > 0:
		trait = random.choice(TRAITS) #Pick a trait for a negative value
		traits.append(trait)
		traitness = -random.randint(1, used)
		if traitness >= -10: #If it's ten or less, incorporate it into another trait
			trait = traits[-1]
		if trait not in characteristics:
			characteristics[trait] = traitness
		else:
			characteristics[trait] += traitness
		used += traitness
	return characteristics

def addChars(char1, char2):
	"""Add two characteristic dictionaries together, summing up their traitness values"""
	char = dict()
	for key, value in char1.iteritems():
		char[key] = value
	for key, value in char2.iteritems():
		if key in char:
			char[key] += value
		else:
			char[key] = value
	return char
