'''Loading data. Not much to look at.
'''

import os
import pygame

data_py = os.path.abspath(os.path.dirname(__file__))
data_dir = os.path.normpath(os.path.join(data_py, '..', 'data'))

def filepath(filename):
    '''Determine the path to a file in the data directory.
    '''
    return os.path.join(data_dir, filename)

def load(filename, mode='rb'):
    '''Open a file in the data directory.

    "mode" is passed as the second arg to open().
    '''
    return open(os.path.join(data_dir, filename), mode)

#Utility functions (modified chimp.py tutorial. Yay!):
def loadImage(name, alpha=False, colorkey=None):
    """Takes a filename and returns a Surface with the image on it.
	name     - Name of the file
	alpha    - True if the image in the file uses per-pixel alpha, False otherwise
	colorkey - The color used to indicate transparency. If the value is -1 the colorkey
will be taken from the top-left corner pixel of the image"""
    fullname = os.path.join(data_dir, name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    if alpha is True:
        image = image.convert_alpha()
    else:
        image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, pygame.RLEACCEL)
    return image
