"""Makes menu handling easy"""
import pygame
import data

start = None
startclick = None
startpos = None
startrect = None

howto = None
howtoclick = None
howtopos = None
howtorect = None
howtomode = False #True when in how-to display mode
instructions = [] #List of text surfaces to render

quit = None
quitclick = None
quitpos = None
quitrect = None

NORM_COLOR = pygame.Color('orange')
HIGH_COLOR = pygame.Color('white')
INSTRUCTION_COLOR = pygame.Color('blue')

def init(x, y, font, insfont):
	"""insfont = instruction font"""
	global start, startclick, startpos, startrect, \
			howto, howtoclick, howtopos, howtorect, \
			quit, quitclick, quitpos, quitrect
	start = font.render("START", 1, NORM_COLOR)
	startclick = font.render("START", 1, HIGH_COLOR)
	startpos = (x, y)
	startrect = start.get_rect(topleft = (x, y)).inflate(6, 10)
	y += startrect.h + 10 #10px padding between rectangles
	howto = font.render("HOW TO PLAY", 1, NORM_COLOR)
	howtoclick = font.render("(It's easy)", 1, HIGH_COLOR)
	howtopos = (x, y)
	howtorect = howto.get_rect(topleft = (x, y)).inflate(6, 10)
	y += startrect.h + 10 #10px padding between rectangles
	quit = font.render("QUIT", 1, NORM_COLOR)
	quitclick = font.render("QUIT", 1, HIGH_COLOR)
	quitpos = (x, y)
	quitrect = quit.get_rect(topleft = (x, y)).inflate(6, 10)
	y += startrect.h + 10 #10px padding between rectangles

	#Write howto
	f = data.load('shortinstructions.txt', 'r')
	for line in f:
		if line.endswith('\n'): #remove newline
			line = line[:-1]
		instructions.append(insfont.render(line, 1, INSTRUCTION_COLOR))
	f.close()

def draw(surf, background):
	if not howtomode: #Render buttons
		surf.blit(background, (0, 0))
		surf.blit(start, startpos)
		surf.blit(howto, howtopos)
		surf.blit(quit, quitpos)
		pygame.draw.rect(surf, NORM_COLOR, startrect, 2)
		pygame.draw.rect(surf, NORM_COLOR, howtorect, 2)
		pygame.draw.rect(surf, NORM_COLOR, quitrect, 2)
	else:
		surf.fill(pygame.Color('orange'))
		x = 10
		y = 20
		for line in instructions:
			surf.blit(line, (x, y))
			y += line.get_rect().h #Move y down by height of text

def drawMouseover(mousepos, surf, background):
	if not howtomode:
		if startrect.collidepoint(mousepos):
			surf.blit(startclick, startpos)
			pygame.draw.rect(surf, HIGH_COLOR, startrect, 2)
		elif howtorect.collidepoint(mousepos):
			surf.blit(background, howtopos, howto.get_rect())
			surf.blit(howtoclick, howtopos)
			pygame.draw.rect(surf, HIGH_COLOR, howtorect, 2)
		elif quitrect.collidepoint(mousepos):
			surf.blit(quitclick, quitpos)
			pygame.draw.rect(surf, HIGH_COLOR, quitrect, 2)

def displayHowto(bool=True):
	global howtomode
	howtomode = bool
